import 'resource_identifier.dart';
import 'link.dart';
import 'utils.dart';

class Relationship {
  final _json = {};

  Relationship.toOne(ResourceIdentifier data, {Link self, Link related})
      : this._internal(data, self: self, related: related);

  Relationship.toMany(List<ResourceIdentifier> data, {Link self, Link related})
      : this._internal(data, self: self, related: related);

  Relationship._internal(data, {Link self, Link related}) {
    _json['data'] = data;
    final links = removeNulls({'self': self, 'related': related});
    if (links.isNotEmpty) {
      _json['links'] = Map.unmodifiable(links);
    }
  }

  toJson() => Map.unmodifiable(_json);
}
