import 'package:json_api_document/src/resource_identifier.dart';

import 'relationship.dart';
import 'primary_data.dart';
import 'link.dart';

class Resource implements PrimaryData {
  Map<String, dynamic> _json;
  final String _type;
  final String _id;

  Resource(String this._type, String this._id,
      {Map<String, dynamic> attributes,
      Map<String, Relationship> relationships,
      Link self})
      : _json = {'type': _type, 'id': _id} {
    if (attributes != null) {
      _json['attributes'] = Map.unmodifiable(attributes);
    }
    if (relationships != null) {
      _json['relationships'] = Map.unmodifiable(relationships);
    }
    if (self != null) {
      _json['links'] = Map.unmodifiable({'self': self});
    }
    _json = Map.unmodifiable(_json);
  }

  toJson() => _json;

  ResourceIdentifier toIdentifier() => ResourceIdentifier(_type, _id);
}
